#include <p18cxxx.h>

/* Watchdog off */
#pragma config WDT = OFF

/* Using 24Mhz crystall */
#pragma config PLLDIV = 6
 
/* 96Mhz/2 */
#pragma config CPUDIV = OSC1_PLL2
#pragma config USBDIV = 2
#pragma config FOSC = HSPLL_HS

#pragma config FCMEN = OFF
#pragma config IESO = OFF
#pragma config BOR = OFF
#pragma config VREGEN = ON
#pragma config MCLRE = OFF
#pragma config PBADEN = OFF

#define FOSC 48000000
#define BAUD 115200
#define BDRT ((((FOSC)/16)/BAUD)-1)

void init_rs232(void)
{
	TRISC |= 0xC0;

	//set asyncronous mode
	RCSTA = (1<<7);
	TXSTA = (1<<5) | (1<<2);
	BAUDCON = 0;
	SPBRG =	(unsigned char) BDRT ;

}

void write_rs232(char * str)
{
		TXREG = 'A';
		while( TXSTAbits.TRMT == 0 ); 
		TXREG = 'B';
		while( TXSTAbits.TRMT == 0 ); 
		TXREG = '\r';
		while( TXSTAbits.TRMT == 0 ); 
		TXREG = '\n';
		while( TXSTAbits.TRMT == 0 ); 
	while( (*str) )
	{
		TXREG = (*str);
		while( TXSTAbits.TRMT == 0 ); 
		str++;
 	}
}

void own_delay(void)
{
	unsigned long i=0;
	while(i<100000) {i++;}
}

rom const char* msg = "LED\r\n";
void main (void)
{
	TRISB=0;
	TRISC = 0;
	/* Reset the LEDs */
	PORTC = 0;
	
	init_rs232();

	while (1)
	{
		/* Light the LEDs */
		PORTCbits.RC2 = !PORTCbits.RC2 ;
		write_rs232(msg);
		own_delay();
	}
}